package com.tashow.cloud.product.service.impl;

import com.tashow.cloud.productapi.api.product.dto.SkuServiceTransportDO;
import com.tashow.cloud.product.mapper.SkuServiceTransportMapper;
import com.tashow.cloud.product.service.SkuServiceTransportService;
import com.tashow.cloud.productapi.api.product.vo.skuservicetransport.SkuServiceTransportPageReqVO;
import com.tashow.cloud.productapi.api.product.vo.skuservicetransport.SkuServiceTransportSaveReqVO;
import com.tashow.cloud.productapi.enums.ErrorCodeConstants;
import org.springframework.stereotype.Service;
import jakarta.annotation.Resource;
import org.springframework.validation.annotation.Validated;
import org.springframework.transaction.annotation.Transactional;

import java.util.*;
import com.tashow.cloud.common.pojo.PageResult;
import com.tashow.cloud.common.pojo.PageParam;
import com.tashow.cloud.common.util.object.BeanUtils;
import static com.tashow.cloud.common.exception.util.ServiceExceptionUtil.exception;

/**
 * 服务遗体运输 Service 实现类
 *
 * @author 芋道源码
 */
@Service
@Validated
public class SkuServiceTransportServiceImpl implements SkuServiceTransportService {

    @Resource
    private SkuServiceTransportMapper skuServiceTransportMapper;

    @Override
    public Long createSkuServiceTransport(SkuServiceTransportSaveReqVO createReqVO) {
        // 插入
        SkuServiceTransportDO skuServiceTransport = BeanUtils.toBean(createReqVO, SkuServiceTransportDO.class);
        skuServiceTransportMapper.insert(skuServiceTransport);
        // 返回
        return skuServiceTransport.getId();
    }

    @Override
    public void updateSkuServiceTransport(SkuServiceTransportSaveReqVO updateReqVO) {
        // 校验存在
        validateSkuServiceTransportExists(updateReqVO.getId());
        // 更新
        SkuServiceTransportDO updateObj = BeanUtils.toBean(updateReqVO, SkuServiceTransportDO.class);
        skuServiceTransportMapper.updateById(updateObj);
    }

    @Override
    public void deleteSkuServiceTransport(Long id) {
        // 校验存在
        validateSkuServiceTransportExists(id);
        // 删除
        skuServiceTransportMapper.deleteById(id);
    }

    private void validateSkuServiceTransportExists(Long id) {
        if (skuServiceTransportMapper.selectById(id) == null) {
            throw exception(ErrorCodeConstants.SKU_SERVICE_TRANSPORT_NOT_EXISTS);
        }
    }

    @Override
    public SkuServiceTransportDO getSkuServiceTransport(Long id) {
        return skuServiceTransportMapper.selectById(id);
    }

    @Override
    public PageResult<SkuServiceTransportDO> getSkuServiceTransportPage(SkuServiceTransportPageReqVO pageReqVO) {
        return null;
    }

}